diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/config-store/model/raw-text-config.cc ns-3.32/src/config-store/model/raw-text-config.cc
--- ns-3.31/src/config-store/model/raw-text-config.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/config-store/model/raw-text-config.cc	2020-10-06 15:35:43.000000000 -0700
@@ -26,6 +26,11 @@
 #include "ns3/log.h"
 #include "ns3/config.h"
 
+#include <istream>
+#include <sstream>
+#include <algorithm>
+#include <functional>
+
 namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("RawTextConfig");
@@ -45,14 +50,14 @@
   delete m_os;
   m_os = 0;
 }
-void 
+void
 RawTextConfigSave::SetFilename (std::string filename)
 {
   NS_LOG_FUNCTION (this << filename);
   m_os = new std::ofstream ();
   m_os->open (filename.c_str (), std::ios::out);
 }
-void 
+void
 RawTextConfigSave::Default (void)
 {
   NS_LOG_FUNCTION (this);
@@ -77,7 +82,7 @@
   RawTextDefaultIterator iterator = RawTextDefaultIterator (m_os);
   iterator.Iterate ();
 }
-void 
+void
 RawTextConfigSave::Global (void)
 {
   NS_LOG_FUNCTION (this);
@@ -89,7 +94,7 @@
       *m_os << "global " << (*i)->GetName () << " \"" << value.Get () << "\"" << std::endl;
     }
 }
-void 
+void
 RawTextConfigSave::Attributes (void)
 {
   NS_LOG_FUNCTION (this);
@@ -127,7 +132,7 @@
       m_is = 0;
     }
 }
-void 
+void
 RawTextConfigLoad::SetFilename (std::string filename)
 {
   NS_LOG_FUNCTION (this << filename);
@@ -137,69 +142,126 @@
 std::string
 RawTextConfigLoad::Strip (std::string value)
 {
+  NS_LOG_FUNCTION (this << value);
   std::string::size_type start = value.find ("\"");
   std::string::size_type end = value.find ("\"", 1);
-  NS_ASSERT (start == 0);
-  NS_ASSERT (end == value.size () - 1);
+  NS_ABORT_MSG_IF (start != 0, "Ill-formed attribute value: " << value);
+  NS_ABORT_MSG_IF (end != value.size () - 1, "Ill-formed attribute value: " << value);
   return value.substr (start+1, end-start-1);
 }
 
-void 
+void
 RawTextConfigLoad::Default (void)
 {
   NS_LOG_FUNCTION (this);
   m_is->clear ();
   m_is->seekg (0);
   std::string type, name, value;
-  *m_is >> type >> name >> value;
-  while (m_is->good ())
+  for (std::string line; std::getline (*m_is, line);)
     {
+      if (!ParseLine (line, type, name, value)) 
+        {
+          continue;
+        }
+
       NS_LOG_DEBUG ("type=" << type << ", name=" << name << ", value=" << value);
       value = Strip (value);
       if (type == "default")
         {
           Config::SetDefault (name, StringValue (value));
         }
-      *m_is >> type >> name >> value;
+      name.clear ();
+      type.clear ();
+      value.clear ();
     }
 }
-void 
+void
 RawTextConfigLoad::Global (void)
 {
   NS_LOG_FUNCTION (this);
   m_is->clear ();
   m_is->seekg (0);
   std::string type, name, value;
-  *m_is >> type >> name >> value;
-  while (m_is->good ())
+  for (std::string line; std::getline (*m_is, line);)
     {
+      if (!ParseLine (line, type, name, value)) 
+        {
+          continue;
+        }
+
       NS_LOG_DEBUG ("type=" << type << ", name=" << name << ", value=" << value);
       value = Strip (value);
       if (type == "global")
         {
           Config::SetGlobal (name, StringValue (value));
         }
-      *m_is >> type >> name >> value;
+      name.clear ();
+      type.clear ();
+      value.clear ();
     }
 }
-void 
+void
 RawTextConfigLoad::Attributes (void)
 {
   NS_LOG_FUNCTION (this);
   m_is->clear ();
   m_is->seekg (0);
-  std::string type, path, value;
-  *m_is >> type >> path >> value;
-  while (m_is->good ())
+  std::string type, name, value;
+  for (std::string line; std::getline (*m_is, line);)
     {
-      NS_LOG_DEBUG ("type=" << type << ", path=" << path << ", value=" << value);
+      if (!ParseLine (line, type, name, value)) 
+        {
+          continue;
+        }
+
+      NS_LOG_DEBUG ("type=" << type << ", name=" << name << ", value=" << value);
       value = Strip (value);
       if (type == "value")
         {
-          Config::Set (path, StringValue (value));
+          Config::Set (name, StringValue (value));
         }
-      *m_is >> type >> path >> value;
+      name.clear ();
+      type.clear ();
+      value.clear ();
+    }
+}
+
+bool
+RawTextConfigLoad::ParseLine (const std::string &line, std::string &type, std::string &name, std::string &value)
+{
+  NS_LOG_FUNCTION (this << line << type << name << value);
+
+  // check for blank line
+  {
+    std::istringstream iss (line);
+    iss >> std::ws;     // remove all blanks line
+    if (!iss.good ())   // eofbit set if no non-blanks
+      {
+        return false;
+      }
+  }
+
+  if (line.front () == '#')
+    {
+      return false;     // comment line
     }
+
+  // for multiline values, append line to value if type and name not empty
+  if (type.empty () && name.empty ())
+    {
+      std::istringstream iss (line);
+      iss >> type >> name >> std::ws;
+      std::getline (iss, value);   // remaining line, includes embedded spaces
+    }
+  else
+    {
+      value.append (line);
+    }
+
+  // two quotes in value signifies a completed (possibly multi-line)
+  // config-store entry, return True to signal load function to
+  // validate value (see Strip method) and set attribute
+  return std::count (value.begin (), value.end (), '"') == 2;
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/config-store/model/raw-text-config.h ns-3.32/src/config-store/model/raw-text-config.h
--- ns-3.31/src/config-store/model/raw-text-config.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/config-store/model/raw-text-config.h	2020-10-06 15:35:43.000000000 -0700
@@ -35,8 +35,9 @@
 class RawTextConfigSave : public FileConfig
 {
 public:
-  RawTextConfigSave ();
-  virtual ~RawTextConfigSave ();
+  RawTextConfigSave (); //!< default constructor
+  virtual ~RawTextConfigSave (); //!< destructor
+  // Inherited
   virtual void SetFilename (std::string filename);
   virtual void Default (void);
   virtual void Global (void);
@@ -54,14 +55,29 @@
 class RawTextConfigLoad : public FileConfig
 {
 public:
-  RawTextConfigLoad ();
-  virtual ~RawTextConfigLoad ();
+  RawTextConfigLoad (); //!< default constructor
+  virtual ~RawTextConfigLoad (); //!< destructor
+  // Inherited
   virtual void SetFilename (std::string filename);
   virtual void Default (void);
   virtual void Global (void);
   virtual void Attributes (void);
 private:
   /**
+   * Parse (potentially multi-) line configs into type, name, and values.
+   * This will return \c false for blank lines, comments (lines beginning with '#'),
+   * and incomplete entries. An entry is considered complete when a type and name
+   * have been found and the value contains two delimiting quotation marks '"'.
+   * \param line the config file line
+   * \param type the config type {default, global, value}
+   * \param name the config attribute name
+   * \param value the value to set
+   * \returns true if all of type, name, and value parsed; false otherwise
+   * 
+   */
+  virtual bool ParseLine (const std::string &line, std::string &type, std::string &name, std::string &value);
+
+  /**
    * Strip out attribute value
    * \param value the input string
    * \returns the updated string
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/examples/build-version-example.cc ns-3.32/src/core/examples/build-version-example.cc
--- ns-3.31/src/core/examples/build-version-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/examples/build-version-example.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,71 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "ns3/command-line.h"
+#include "ns3/version.h"
+
+#include <iostream>
+#include <iomanip>
+#include <string>
+
+/**
+ * \file
+ * \ingroup core-examples
+ * Example program illustrating use of ns3::Version.
+ */
+
+using namespace ns3;
+
+int main (int argc, char *argv[])
+{
+
+  CommandLine cmd (__FILE__);
+  cmd.Usage ("Version class example program.\n"
+             "\n"
+             "This program demonstrates the various outputs from the Version class");
+  cmd.Parse (argc, argv);
+
+  std::cout << std::endl;
+  std::cout << cmd.GetName () << ":" << std::endl;
+
+  //Print the source version used to build this example
+  std::cout << "Program Version (according to CommandLine): ";
+  cmd.PrintVersion (std::cout);
+  std::cout << std::endl;
+
+  Version version;
+  std::cout << "Version fields:\n"
+            << "LongVersion:        " << version.LongVersion () << "\n"
+            << "ShortVersion:       " << version.ShortVersion () << "\n"
+            << "BuildSummary:       " << version.BuildSummary () << "\n"
+            << "VersionTag:         " << version.VersionTag () << "\n"
+            << "Major:              " << version.Major () << "\n"
+            << "Minor:              " << version.Minor () << "\n"
+            << "Patch:              " << version.Patch () << "\n"
+            << "ReleaseCandidate:   " << version.ReleaseCandidate () << "\n"
+            << "ClosestAncestorTag: " << version.ClosestAncestorTag () << "\n"
+            << "TagDistance:        " << version.TagDistance () << "\n"
+            << "CommitHash:         " << version.CommitHash () << "\n"
+            << "BuildProfile:       " << version.BuildProfile () << "\n"
+            << "WorkingTree:        " << (version.DirtyWorkingTree () ? "dirty" : "clean")
+            << std::endl;
+
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/examples/command-line-example.cc ns-3.32/src/core/examples/command-line-example.cc
--- ns-3.31/src/core/examples/command-line-example.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/examples/command-line-example.cc	2020-10-06 15:35:43.000000000 -0700
@@ -28,7 +28,7 @@
  * \file
  * \ingroup core-examples
  * \ingroup commandline
- * \brief Example program illustrating use of ns3::CommandLine.
+ * Example program illustrating use of ns3::CommandLine.
  */
 
 using namespace ns3;
@@ -104,7 +104,13 @@
 
   // Show initial values:
   std::cout << std::endl;
-  std::cout << cmd.GetName () << std::endl;
+  std::cout << cmd.GetName () << ":" << std::endl;
+
+  //Print the source version used to build this example
+  std::cout << "Program Version: ";
+  cmd.PrintVersion (std::cout);
+  std::cout << std::endl;
+
   std::cout << "Initial values:" << std::endl;
 
   std::cout << std::left << std::setw (10) << "intArg:"
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/examples/fatal-example.cc ns-3.32/src/core/examples/fatal-example.cc
--- ns-3.31/src/core/examples/fatal-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/examples/fatal-example.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,84 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "ns3/fatal-error.h"
+#include "ns3/assert.h"
+#include "ns3/simulator.h"
+
+#include <iostream>
+
+/**
+ * \file
+ * \ingroup core-examples
+ * \ingroup ptr
+ * Example program illustrating use of the NS_FATAL error handlers.
+ */
+
+using namespace ns3;
+
+void
+FatalNoMsg (void)
+{
+  std::cerr << "\nEvent triggered fatal error without message, and continuing:"
+	    << std::endl;
+  NS_FATAL_ERROR_NO_MSG_CONT ();
+}
+
+void
+FatalCont (void)
+{
+  std::cerr << "\nEvent triggered fatal error, with custom message, and continuing:"
+	    << std::endl;
+  NS_FATAL_ERROR_CONT ("fatal error, but continuing");
+}
+
+void
+Fatal (void)
+{
+  std::cerr << "\nEvent triggered fatal error, with message, and terminating:"
+	    << std::endl;
+  NS_FATAL_ERROR ("fatal error, terminating");
+}
+
+int
+main (int argc, char ** argv)
+{
+  // First schedule some events
+  Simulator::Schedule (Seconds (1), FatalNoMsg);
+  Simulator::Schedule (Seconds (2), FatalCont);
+  Simulator::Schedule (Seconds (3), Fatal);
+  
+
+  // Show some errors outside of simulation time
+  std::cerr << "\nFatal error with custom message, and continuing:" << std::endl;
+  NS_FATAL_ERROR_CONT ("fatal error, but continuing");
+
+  std::cerr << "\nFatal error without message, and continuing:" << std::endl;
+  NS_FATAL_ERROR_NO_MSG_CONT ();
+  
+  // Now run the simulator
+  Simulator::Run ();
+
+  // Should not get here
+  NS_FATAL_ERROR ("fatal error, terminating");
+  NS_ASSERT_MSG (false, "Should not get here.");
+
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/examples/wscript ns-3.32/src/core/examples/wscript
--- ns-3.31/src/core/examples/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/examples/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -50,6 +50,15 @@
     obj = bld.create_ns3_program('system-path-examples',
                                  ['core'])
     obj.source = 'system-path-examples.cc'
+    
+    obj = bld.create_ns3_program('fatal-example',
+                                 ['core'])
+    obj.source = 'fatal-example.cc'
+
+    if bld.env['ENABLE_BUILD_VERSION']:
+        obj = bld.create_ns3_program('build-version-example',
+                                 ['core'])
+        obj.source = 'build-version-example.cc'
 
     if bld.env['ENABLE_THREADING'] and bld.env["ENABLE_REAL_TIME"]:
         obj = bld.create_ns3_program('main-test-sync', ['network'])
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/attribute-container-accessor-helper.h ns-3.32/src/core/model/attribute-container-accessor-helper.h
--- ns-3.31/src/core/model/attribute-container-accessor-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/model/attribute-container-accessor-helper.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,101 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Caliola Engineering, LLC.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Jared Dulmage <jared.dulmage@caliola.com>
+ */
+
+#ifndef ATTRIBUTE_CONTAINER_ACCESSOR_HELPER_H
+#define ATTRIBUTE_CONTAINER_ACCESSOR_HELPER_H
+
+#include "attribute-container.h"
+
+#include <ns3/attribute-helper.h>
+
+
+#include <type_traits>
+#include <list>
+
+namespace ns3 {
+
+/**
+ * \ingroup attributeimpl
+ *
+ * DoMakeAccessorHelperOne specialization for member containers
+ *
+ * The template parameter list contains an extra parameter that disambiguates
+ * the templated Ptr type from container types by taking advantage of the fact
+ * that container types have multiple template arguments and Ptr has only one.
+ * This disambiguation works but is not sufficiently robust as a long term solution.
+ *
+ * \tparam V  \explicit The specific AttributeValue type to use to represent
+ *            the Attribute.
+ * \tparam T  \deduced The class holding the data member.
+ * \tparam U  \deduced The type of the container.
+ * \tparam I  \deduced The type of item (s) within the container.
+ * \param [in]  memberContainer  The address of the data member.
+ * \returns The AttributeAccessor.
+ */
+template <typename V, typename T, template <typename...> class U, typename ...I,
+          typename = typename std::enable_if< (sizeof...(I) > 1), void>::type >
+inline
+Ptr<const AttributeAccessor>
+DoMakeAccessorHelperOne (U<I...> T::*memberContainer)
+{
+  /* AttributeAcessor implementation for a class member variable. */
+  class MemberContainer : public AccessorHelper<T,V>
+  {
+    public:
+    /*
+     * Construct from a class data member address.
+     * \param [in] memberContainer The class data member address.
+     */
+    MemberContainer (U<I...> T::*memberContainer)
+      : AccessorHelper<T,V> (),
+        m_memberContainer (memberContainer)
+    {}
+    private:
+    virtual bool DoSet (T *object, const V *v) const {
+      // typename AccessorTrait<U<I>::value_type>::Result tmp;
+      // bool ok = v->GetAccessor (tmp);
+      // if (!ok)
+      //   {
+      //     return false;
+      //   }
+      auto src = v->Get ();
+      (object->*m_memberContainer).clear ();
+      std::copy (src.begin (), src.end (), std::inserter ((object->*m_memberContainer), (object->*m_memberContainer).end ()));
+      return true;
+    }
+    virtual bool DoGet (const T *object, V *v) const {
+      v->Set (object->*m_memberContainer);
+      return true;
+    }
+    virtual bool HasGetter (void) const {
+      return true;
+    }
+    virtual bool HasSetter (void) const {
+      return true;
+    }
+
+    U<I...> T::*m_memberContainer;  // Address of the class data member.
+  };
+  return Ptr<const AttributeAccessor> (new MemberContainer (memberContainer), false);
+}
+
+} // namespace ns3
+
+#endif  // ATTRIBUTE_CONTAINER_ACCESSOR_HELPER_H
\ No newline at end of file
